###################################################
### chunk number 1: 
###################################################
library(mlegp)


###################################################
### chunk number 2: 
###################################################
x = -5:5
z1 = 10 - 5*x + rnorm(length(x))
z2 = 7 * sin(x) + rnorm(length(x))
fitMulti = mlegp(x, cbind(z1,z2))
plot(fitMulti)


###################################################
### chunk number 3: 
###################################################
plot(fitMulti)


###################################################
### chunk number 5: 
###################################################
fitMulti


###################################################
### chunk number 6: 
###################################################
fitMulti[[1]]


###################################################
### chunk number 7: 
###################################################
x = c(1:10, 1:10, 1:10)
y = x + rnorm(length(x), sd = 1)
fit = mlegp(x,y, nugget = 1, nugget.known = 1)


###################################################
### chunk number 8: 
###################################################
fit = mlegp(x,y, nugget.known = 1)


###################################################
### chunk number 9: 
###################################################
fit$nugget 


###################################################
### chunk number 10: 
###################################################
x = seq(0,1,length.out=20)
z = x + rnorm(length(x), sd = 0.10*x)   # variance is not constant


###################################################
### chunk number 11: 
###################################################
fit1 = mlegp(x,z, nugget = mean((0.1*x)**2))


###################################################
### chunk number 12: 
###################################################
fit2 = mlegp(x,z, nugget = (.1*x)**2)


###################################################
### chunk number 13: 
###################################################
fit3 = mlegp(x,z, nugget.known = 1, nugget = (.1*x)**2)


###################################################
### chunk number 14: 
###################################################
sqrt(mean((x-predict(fit1))**2))
sqrt(mean((x-predict(fit2))**2))
sqrt(mean((x-predict(fit3))**2))


###################################################
### chunk number 15: 
###################################################
library(mlegp)


###################################################
### chunk number 16: 
###################################################
x = seq(-4,4,by=.05)
p = 1:10
y = matrix(0,length(p), length(x))
for (i in 1:length(p)) {
           y[i,] = sin(x) + .2*i + rnorm(length(x), sd  = .01)
}


###################################################
### chunk number 17:  eval=FALSE
###################################################
## ## we now have 10 functional observations (each of length 100) ##
## for (i in p) {
## 	plot(x,y[i,], type = "l", col = i, ylim = c(min(y), max(y)))
##         par(new=TRUE)
## }


###################################################
### chunk number 18: 
###################################################
     ## we now have 10 functional observations (each of length 100) ##
     for (i in p) {
            plot(x,y[i,], type = "l", col = i, ylim = c(min(y), max(y)))
            par(new=TRUE)
     }


###################################################
### chunk number 19: 
###################################################
     numPCs = 2
     singularValueImportance(t(y))[numPCs]


###################################################
### chunk number 20: 
###################################################
     fitPC = mlegp(p, t(y), PC.num = numPCs)


###################################################
### chunk number 21: 
###################################################
     ## reconstruct the output Y = UDV'
     Vprime = matrix(0,numPCs,length(p))
     Vprime[1,] = predict(fitPC[[1]])
     Vprime[2,] = predict(fitPC[[2]])
     predY = fitPC$UD %*% Vprime


